/* Copyright (c) 2001, 2011, Oracle and/or its affiliates. All rights reserved. */

  /*
  |  Outside In Viewer Technology - Include
  |
  |  Include:      SCCVW.H
  |  Environment:  Portable
  |  Function:     Primary definitions for
  |                Outside In Viewer Technology Specification 4.0
  |
  */

#ifndef SCCVW_H
#define SCCVW_H

#ifdef WINDOWS
#ifndef SCC_PACK_SET
#define SCC_PACK_SET 1
#define SCC_PACKED_BY_SCCVW_H 1
#pragma pack(push,8)
#endif /* SCC_PACK_SET */
#endif /* WINDOWS */

#include <scctype.h>
#include <sccop.h>
#include <sccanno.h>

#if defined(_DARWIN_SOURCE)
#define MAX_PATH                256
#define SCCVW_DISPLAYNAMEMAX    MAX_PATH
#define SCCVW_FILENAMEMAX       MAX_PATH
#define SCCVW_FILEIDNAMEMAX     80
#define SCCVW_DEFAULTMENUMAX    5000

#include <sccvw_osx.h>

#endif /* _DARWIN_SOURCE */

#ifdef WINDOWS
#include "sccvw_w.h"
#endif /* WINDOWS */

#if defined(UNIX) && !defined(_DARWIN_SOURCE)
#define MAX_PATH                256
#define SCCVW_DISPLAYNAMEMAX    MAX_PATH
#define SCCVW_FILENAMEMAX       MAX_PATH

#define SCCVW_FILEIDNAMEMAX     80
#define SCCVW_DEFAULTMENUMAX    5000

#include "sccvw_u.h"
#endif /* UNIX */

#ifdef NLM
#include "sccvw_l.h"
#endif /* NLM */

#include "sccid.h"
#include "sccio.h"
#include "sccfi.h"

#include "sccerr.h"

#ifdef __cplusplus
extern "C"
{
#endif

  /*
  |  Messages TO SCCVIEWER window
  */

#define SCCVW_FIRSTTOMESSAGE    SCCVW_START+1000

#define SCCVW_CLOSEFILE         SCCVW_START+1001

#define SCCVW_COPYTOCLIP        SCCVW_START+1004
#define SCCVW_SETIDLEBITMAP     SCCVW_START+1005
#define SCCVW_UNDO                      SCCVW_START+1006
#define SCCVW_REDO                      SCCVW_START+1007

#define SCCVW_GETFILEINFO       SCCVW_START+1010
#define SCCVW_GETPROPERTY		SCCVW_START+1011

#define SCCVW_GETCLIPINFO       SCCVW_START+1013

#define SCCVW_SEARCH            SCCVW_START+1017
#define SCCVW_SEARCHNEXT        SCCVW_START+1018
#define SCCVW_GETDISPLAYINFO    SCCVW_START+1019

#define SCCVW_DOMENUITEM        SCCVW_START+1022

#define SCCVW_PRINT             SCCVW_START+1025
#define SCCVW_PRINTSETUP        SCCVW_START+1026

#define SCCVW_SELECTALL         SCCVW_START+1028

#define SCCVW_RENDERRTFTOFILE   SCCVW_START+1030  /*  Vendor Specific */
#define SCCVW_SEARCHDIALOG      SCCVW_START+1031
#define SCCVW_SETMENUMAX        SCCVW_START+1032

#define SCCVW_PRINTEX           SCCVW_START+1040
#define SCCVW_SETDISPLAYNAME    SCCVW_START+1041
#define SCCVW_ADDANNOTATION     SCCVW_START+1042
#define SCCVW_CLEARANNOTATIONS  SCCVW_START+1043
#define SCCVW_GOTOANNOTATION    SCCVW_START+1044
#define SCCVW_GETEDITANNOTATIONS        SCCVW_START+1045

#define SCCVW_SETOPTION         SCCVW_START+1050
#define SCCVW_GETOPTION         SCCVW_START+1051
#define SCCVW_VIEWFILE          SCCVW_START+1052
#define SCCVW_DRAWPAGE          SCCVW_START+1053
#define SCCVW_INITDRAWPAGE      SCCVW_START+1054


#define SCCVW_DEINITDRAWPAGE    SCCVW_START+1057
#define SCCVW_DODIALOG          SCCVW_START+1058
#define SCCVW_IDLE              SCCVW_START+1059
#define SCCVW_SAVEOPTIONS       SCCVW_START+1060
#define SCCVW_GETRAWTEXT        SCCVW_START+1061
#define SCCVW_FINDANNOTATION    SCCVW_START+1062
#define SCCVW_FINDPOSITION      SCCVW_START+1063
#define SCCVW_MAPPOSITION       SCCVW_START+1064
#define SCCVW_SETSELECTION      SCCVW_START+1065
#define SCCVW_DISPLAYPOSITION   SCCVW_START+1066
#define SCCVW_COPY              SCCVW_START+1067
#define SCCVW_HILITESTYLE       SCCVW_START+1068
#define SCCVW_HSCROLL           SCCVW_START+1069
#define SCCVW_VSCROLL           SCCVW_START+1070
#define SCCVW_COMPPOSITIONS     SCCVW_START+1071
#define SCCVW_GETPROPERTYSHEETPAGE  SCCVW_START+1072
#define SCCVW_INITPROPERTYSHEETPAGES  SCCVW_START+1073
#define SCCVW_DEINITPROPERTYSHEETPAGES  SCCVW_START+1074
#define SCCVW_VIEWAS               SCCVW_START+1075
#define SCCVW_GETHIOFILE           SCCVW_START+1076
#define SCCVW_GETANNOTATIONDATA    SCCVW_START+1077
#define SCCVW_STATUS               SCCVW_START+1078
#define SCCVW_GETIDEALWINDOWSIZE   SCCVW_START+1079
#define SCCVW_GETDRAWPAGEINFO      SCCVW_START+1080
#define SCCVW_GETSECTIONCOUNTINFO  SCCVW_START+1081
#define SCCVW_GETIDFIRSTCHANGE   SCCVW_START+1082
#define SCCVW_GETTREECOUNT       SCCVW_START+1083
#define SCCVW_GETTREENODE        SCCVW_START+1084
#define SCCVW_SAVETREENODE       SCCVW_START+1085
#define SCCVW_DRAMAMINE_TMVT_1   SCCVW_START+1086
#define SCCVW_DRAMAMINE_TMVT_2   SCCVW_START+1087
#define SCCVW_DRAMAMINE_TMVT_3   SCCVW_START+1088
#define SCCVW_DRAMAMINE_TMVT_4   SCCVW_START+1089
#define SCCVW_MAPTREEPOSITION    SCCVW_START+1090
#define SCCVW_GETSECTIONNAME           SCCVW_START+1091
#define SCCVW_WRAPDC                   SCCVW_START+1092
#define SCCVW_UNWRAPDC                 SCCVW_START+1093
#define SCCVW_SEARCHEX                 SCCVW_START+1094

#ifdef WINDOWS
#define SCCVW_SAVEFILE                  SCCVW_START+1095
#define SCCVW_GETEDITFILEHANDLE         SCCVW_START+1096
#define SCCVW_GETEDITANNOTATIONLIST     SCCVW_START+1097
#define SCCVW_REGISTEREDITSORTFUNCTION  SCCVW_START+1098
#define SCCVW_STOREANNOTATIONS          SCCVW_START+1099
#define SCCVW_LASTTOMESSAGE             SCCVW_START+1099
#else
#define SCCVW_LASTTOMESSAGE            SCCVW_START+1094
#endif

  /*
  |  Messages FROM SCCVIEWER window
  */

#define SCCVW_FIRSTFROMMESSAGE  SCCVW_START+1100

#define SCCVW_SELCHANGE         SCCVW_START+1105
#define SCCVW_DISPLAYCHANGE     SCCVW_START+1107
#define SCCVW_VIEWTHISFILE      SCCVW_START+1109
#define SCCVW_FILECHANGE        SCCVW_START+1110
/* Legacy message, #define SCCVW_RAWTEXT           SCCVW_START+1111 */
#define SCCVW_ANNOTATIONEVENT   SCCVW_START+1112
#define SCCVW_OPTIONCHANGE      SCCVW_START+1113
#define SCCVW_DOHELP            SCCVW_START+1114
#define SCCVW_CONTEXTMENU       SCCVW_START+1115
#define SCCVW_ENABLEAPP         SCCVW_START+1116
#define SCCVW_SETVSCROLLPOSITION SCCVW_START+1117
#define SCCVW_SETVSCROLLPAGESIZE SCCVW_START+1118
#define SCCVW_SETVSCROLLRANGE    SCCVW_START+1119
#define SCCVW_SETVSCROLLSTATE    SCCVW_START+1120
#define SCCVW_SETHSCROLLPOSITION SCCVW_START+1121
#define SCCVW_SETHSCROLLPAGESIZE SCCVW_START+1122
#define SCCVW_SETHSCROLLRANGE    SCCVW_START+1123
#define SCCVW_SETHSCROLLSTATE    SCCVW_START+1124
#define SCCVW_KEYDOWN            SCCVW_START+1125
#define SCCVW_WM_HELP            SCCVW_START+1126 /* Windows Only */
#define SCCVW_WM_CONTEXTMENU     SCCVW_START+1127 /* Windows Only */
#define SCCVW_RAWTEXTEVENT       SCCVW_START+1128
#define SCCVW_BAILOUT            SCCVW_START+1129
#define SCCVW_READAHEADDONE      SCCVW_START+1130
#define SCCVW_TMPCREATE          SCCVW_START+1131
#define SCCVW_MAPPROB            SCCVW_START+1132


#define SCCVW_SETVSCROLLRANGEMIN SCCVW_START+1135
#define SCCVW_SETVSCROLLRANGEMAX SCCVW_START+1136
#define SCCVW_GETFILEACCESSDATA  SCCVW_START+1137

#define SCCVW_LASTFROMMESSAGE    SCCVW_START+1137  /* Must be updated with each message added */

  /*
  |  Messages TO SCCVIEWER window for Dramamine
  */

#define SCCVW_DRAMAMINE_FIRSTTOMESSAGE  SCCVW_START+2000

#define SCCVW_DRAMAMINE_1       SCCVW_START+2000

#define SCCVW_DRAMAMINE_LASTTOMESSAGE   SCCVW_START+2000

/*
  |  SCCVWVIEWFILE structure
  */

typedef struct SCCVWVIEWFILE40tag
  {
  VTDWORD       dwSize;
  VTDWORD       dwSpecType;
  VTVOID *      pSpec;
  VTDWORD       dwViewAs;
  VTBOOL        bUseDisplayName;
  VTTCHAR       szDisplayName[SCCVW_DISPLAYNAMEMAX];
  VTBOOL        bDeleteOnClose;
  VTDWORD       dwFlags;
#ifdef WIN64
  DWORD_PTR     dwReserved1;
  DWORD_PTR     dwReserved2;
#else
  VTDWORD       dwReserved1;
  VTDWORD       dwReserved2;
#endif
  } SCCVWVIEWFILE40, * PSCCVWVIEWFILE40;

typedef struct SCCVWVIEWFILE80tag
  {
  VTDWORD         dwSize;
  VTDWORD         dwSpecType;
  VTVOID *        pSpec;
  VTDWORD         dwViewAs;
  VTBOOL          bUseDisplayName;
  VTWORD          szDisplayName[SCCVW_DISPLAYNAMEMAX];
  VTBOOL          bDeleteOnClose;
  VTDWORD         dwFlags;
#ifdef WIN64
  DWORD_PTR       dwReserved1;
  DWORD_PTR       dwReserved2;
#else
  VTDWORD         dwReserved1;
  VTDWORD         dwReserved2;
#endif
  } SCCVWVIEWFILE80, * PSCCVWVIEWFILE80;

/* Possible values for dwFlags above */
#define SCCVW_GOTOBOOKMARK      0x00000001  /* Indicates dwReserved1 points to a bookmark name */

  /*
  |
  |  SCCVWFILEINFO structure
  |
  */

typedef struct SCCVWFILEINFO40tag
  {
    VTDWORD       dwSize;
    VTTCHAR       szDisplayName[SCCVW_DISPLAYNAMEMAX];
    VTDWORD       dwFileId;
    VTTCHAR       szFileIdName[SCCVW_FILEIDNAMEMAX];
    VTTCHAR       szFileName[SCCVW_FILENAMEMAX];
  } SCCVWFILEINFO40, * PSCCVWFILEINFO40;

typedef struct SCCVWFILEINFO80tag
  {
  VTDWORD       dwSize;
  VTWORD        szDisplayName[SCCVW_DISPLAYNAMEMAX];
  VTDWORD       dwFileId;
  VTWORD        szFileIdName[SCCVW_FILEIDNAMEMAX];
  VTWORD        szFileName[SCCVW_FILENAMEMAX];
  } SCCVWFILEINFO80, * PSCCVWFILEINFO80;


   /*
   | SCCVWGETPROP  structure
   */

typedef struct SCCVWGETPROPtag
{
	VTDWORD		dwSize;		/* [IN] structure size in bytes */
	VTDWORD		dwPropId;	/* [IN or OUT] property name ID */
	VTLPVOID	pName;		/* [IN] pointer to buffer to receive property name (name in unicode WCHARS, 2 bytes long) */
	VTDWORD		dwNameSize; /* [IN/OUT] IN: size of pName in bytes. OUT: Bytes copied into pName*/
	VTLPVOID	pData;		/* [IN] pointer to buffer to receive property data */
	VTDWORD		dwDataSize; /* [IN/OUT] IN: size of pData in bytes. OUT: Bytes copied into pData*/
	VTDWORD		dwDataType;	/* [OUT] type of data in pData */
} SCCVWGETPROP, *PSCCVWGETPROP;

#define SCCVW_GETPROP_FIRST		0
#define SCCVW_GETPROP_NEXT		1
#define SCCVW_GETPROP_PREV		2
#define SCCVW_GETPROP_BYID		3
#define SCCVW_GETPROP_BYINDEX	4

#define SCCVW_PROPTYPE_UNKNOWN 0
#define SCCVW_PROPTYPE_STRING  1

   /*
   | SCCVWPOS  structure
   */

typedef SCCPOS   SCCVWPOS, *PSCCVWPOS;

  /*
  |
  |  SCCVWSEARCHINFO structure
  |
  */

typedef struct SCCVWSEARCHINFO40tag
  {
  VTDWORD       dwSize;
  VTTCHAR       siText[80];
  VTWORD        siTextLen;
  VTWORD        siType;
  VTWORD        siFrom;
  VTWORD        siDirection;
  } SCCVWSEARCHINFO40, * PSCCVWSEARCHINFO40;

typedef struct SCCVWSEARCHINFO80tag
  {
  VTDWORD       dwSize;
  VTWORD        siText[80];
  VTWORD        siTextLen;
  VTWORD        siType;
  VTWORD        siFrom;
  VTWORD        siDirection;
  } SCCVWSEARCHINFO80, * PSCCVWSEARCHINFO80;

  /*
  |  Possible values for siType in SCCVWSEARCHINFO
  */

#define SCCVW_SEARCHCASE    0x0001
#define SCCVW_SEARCHNOCASE  0x0002

  /*
  |  Possible values for siFrom in SCCVWSEARCHINFO
  */

#define SCCVW_SEARCHTOP      0x0001
#define SCCVW_SEARCHBOTTOM   0x0002
#define SCCVW_SEARCHCURRENT  0x0004

  /*
  |  Possible values for siDirection in the SCCVWSEARCHINFO structure
  |  and wParam in SCCVW_SEARCHNEXT message
  */

#define SCCVW_SEARCHSAME     0x0000  /*used only in SCCVW_SEARCHNEXT message */
#define SCCVW_SEARCHFORWARD  0x0001
#define SCCVW_SEARCHBACK     0x0002

  /*
  |
  |  SCCVWVIEWTHISFILE structure
  |
  */

typedef struct SCCVWVIEWTHISFILE40tag
  {
  VTDWORD             dwSize;
  SCCVWVIEWFILE40     sViewFile;
  VTWORD              wFileTime;
  VTWORD              wFileDate;
  VTDWORD             dwFileSize;
  } SCCVWVIEWTHISFILE40, * PSCCVWVIEWTHISFILE40;

typedef struct SCCVWVIEWTHISFILE80tag
  {
  VTDWORD           dwSize;
  SCCVWVIEWFILE80   sViewFile;
  VTWORD            wFileTime;
  VTWORD            wFileDate;
  VTDWORD           dwFileSize;
  } SCCVWVIEWTHISFILE80, * PSCCVWVIEWTHISFILE80;

  /*
  |
  |  SCCVWDISPLAYINFO structure
  |
  */

#define MAX_DISPLAYINFO_SZNAME_SIZE 128
typedef struct SCCVWDISPLAYINFO40tag
  {
  VTDWORD       dwSize;
  VTTCHAR       szName[MAX_DISPLAYINFO_SZNAME_SIZE];
  VTSYSPARAM    hMenu;
  VTDWORD       dwFunctions;
  VTDWORD       dwType;
  } SCCVWDISPLAYINFO40, * PSCCVWDISPLAYINFO40;

typedef struct SCCVWDISPLAYINFO80tag
{
    VTDWORD      dwSize;
    VTWORD       szName[ MAX_DISPLAYINFO_SZNAME_SIZE ];
    VTSYSPARAM   hMenu;
    VTDWORD      dwFunctions;
    VTDWORD      dwType;
} SCCVWDISPLAYINFO80, *PSCCVWDISPLAYINFO80;

  /*
  |  Possible values for dwType in SCCVWDISPLAYINFO
  */

#define SCCVWTYPE_NONE    1  /* no file open in this view */
#define SCCVWTYPE_UNKNOWN 2  /* unknown section type */
#define SCCVWTYPE_WP      3  /* word processor section */
#define SCCVWTYPE_SS      4  /* spreadsheet section */
#define SCCVWTYPE_DB      5  /* database section */
#define SCCVWTYPE_HEX     6  /* hex view of any file */
#define SCCVWTYPE_IMAGE   7  /* bitmap image */
#define SCCVWTYPE_ARCHIVE 8  /* archive */
#define SCCVWTYPE_VECTOR  9  /* bitmap image */
#define SCCVWTYPE_SOUND   10  /* sound file */


   /*
   | SCCVWCOLORREF structure
   | This structure should be set using the SCCVWRGB macro.
   */

typedef SCCANNOCOLORREF SCCVWCOLORREF;

#define SCCVWRGB(r,g,b)   SCCANNORGB(r,g,b)

    /*
    |   Flags in wParam of SCCVW_FILECHANGE
    */

#define SCCVW_FC_CLOSED     0x0001      /* File was closed */
#define SCCVW_FC_OPENED     0x0002      /* File was opened */
#define SCCVW_FC_INOPEN     0x0004      /*
                                                                        |   When used with SCCVW_FC_CLOSED means that the close
                                        |   is in response to an SCCVW_VIEWFILE message and another
                                                                        |   SCCVW_FILECHANGE can be expected.
                                                                        |   Use this flag to avoid flashy UI
                                                                        */

  /*
  |
  |  SCCVWFONTSPEC structure
  |
  */

typedef struct SCCVWFONTSPECtag
{
    VTTCHAR   szFace[40];
    VTWORD    wHeight;
    VTWORD    wAttr;
    VTWORD    wType;
} SCCVWFONTSPEC, * LPSCCVWFONTSPEC;

#define SCCVW_CHARATTR_NORMAL         0x0000
#define SCCVW_CHARATTR_UNDERLINE      0x0001
#define SCCVW_CHARATTR_ITALIC         0x0002
#define SCCVW_CHARATTR_BOLD           0x0004
#define SCCVW_CHARATTR_STRIKEOUT      0x0008
#define SCCVW_CHARATTR_SMALLCAPS      0x0010
#define SCCVW_CHARATTR_OUTLINE        0x0020
#define SCCVW_CHARATTR_SHADOW         0x0040
#define SCCVW_CHARATTR_CAPS           0x0080
#define SCCVW_CHARATTR_SUBSCRIPT      0x0100
#define SCCVW_CHARATTR_SUPERSCRIPT    0x0200
#define SCCVW_CHARATTR_DUNDERLINE     0x0400
#define SCCVW_CHARATTR_WORDUNDERLINE  0x0800
#define SCCVW_CHARATTR_DOTUNDERLINE   0x1000
#define SCCVW_CHARATTR_DASHUNDERLINE  0x2000


   /*
   |  General Font Specification
   */

#define SCCVW_CHARSET_SHIFTJIS      0x10
#define SCCVW_CHARSET_HANGEUL       0x11
#define SCCVW_CHARSET_CHINESEBIG5   0x12
#define SCCVW_CHARSET_ANSI          0x13
#define SCCVW_CHARSET_OEM           0x14
#define SCCVW_CHARSET_MAC           0x15
#define SCCVW_CHARSET_SYMBOL        0x16
#define SCCVW_CHARSET_GB2312        0x17
#define SCCVW_CHARSET_HEBREW        0x18
#define SCCVW_CHARSET_ARABIC        0x19
#define SCCVW_CHARSET_GREEK         0x1A
#define SCCVW_CHARSET_TURKISH       0x1B
#define SCCVW_CHARSET_THAI          0x1C
#define SCCVW_CHARSET_EASTEUROPE    0x1D
#define SCCVW_CHARSET_RUSSIAN       0x1E
#define SCCVW_CHARSET_BALTIC        0x1F

#define PSCCVWFONTSPEC LPSCCVWFONTSPEC

   /*
   |  SCCVWGETRAWTEXT50 structure
   */

typedef struct SCCVWGETRAWTEXT50tag
{
    VTDWORD    dwSize;
    VTDWORD    dwOptions;
    VTDWORD    dwACC;
    VTHANDLE   hText;
    VTDWORD    dwCharCount;
    VTDWORD   dwCharSet;
    VTDWORD   dwTextBufSize;
    VTDWORD    dwTextOffset;
} SCCVWGETRAWTEXT50, * PSCCVWGETRAWTEXT50;

  /*
  |  wParams for SCCVW_ADDANNOTATION message
  */

#define SCCVW_HILITETEXT        SCCANNO_HILITETEXT
#define SCCVW_INSERTICON        SCCANNO_INSERTICON
#define SCCVW_HIDETEXT          SCCANNO_HIDETEXT
#define SCCVW_INSERTBITMAP      SCCANNO_INSERTBITMAP
#define SCCVW_INSERTTEXT        SCCANNO_INSERTTEXT
#define SCCVW_INSERTPARABREAK   SCCANNO_INSERTPARABREAK
#define SCCVW_HIDEPARABREAK     SCCANNO_HIDEPARABREAK

  /*
  |
  |  SCCVWHIDETEXT* structures
  |
  */

typedef SCCANNOHIDETEXT40   SCCVWHIDETEXT40, *PSCCVWHIDETEXT40;
typedef SCCANNOHIDETEXT41   SCCVWHIDETEXT41, *PSCCVWHIDETEXT41;
typedef SCCANNOHIDETEXT80   SCCVWHIDETEXT80, *PSCCVWHIDETEXT80;
typedef SCCANNOHIDETEXT81   SCCVWHIDETEXT81, *PSCCVWHIDETEXT81;

  /*
  |
  |  SCCVWHILITETEXT* structures
  |
  */

typedef SCCANNOHILITETEXT40   SCCVWHILITETEXT40, *PSCCVWHILITETEXT40;
typedef SCCANNOHILITETEXT41   SCCVWHILITETEXT41, *PSCCVWHILITETEXT41;
typedef SCCANNOHILITETEXT81   SCCVWHILITETEXT81, *PSCCVWHILITETEXT81;

/*
 |  dwUser flags for internal annotations (bookmarks, hyperlinks, etc.)
 */

#define SCCVW_USERBOOKMARKTAG        SCCANNO_USERBOOKMARKTAG
#define SCCVW_USERHYPERTAG           SCCANNO_USERHYPERTAG
#define SCCVW_USERVWSEARCHTAG        SCCANNO_USERVWSEARCHTAG

#define SCCVW_USERSEARCHTAG          SCCANNO_USERVWSEARCHTAG
#define SCCVW_USERPAGETAG            SCCANNO_USERPAGETAG
#define SCCVW_USEROBJECTTAG          SCCANNO_USEROBJECTTAG

#define SCCVW_LOOKINGFORNONTEXTTAG   SCCANNO_LOOKINGFORNONTEXTTAG   /* Any of the above. */

/*
| Internal use of dwDisplay
*/

#define SCCVW_STYLESEARCHTAG    SCCANNO_STYLESEARCHTAG
#define SCCVW_STYLEOBJECTTAG    SCCANNO_STYLEOBJECTTAG
#define SCCVW_STYLEHYPERTAG     SCCANNO_STYLEHYPERTAG
#define SCCVW_STYLEBOOKMARKTAG  SCCANNO_STYLEBOOKMARKTAG

  /*
  |
  |  SCCVWINSERTICON* structures
  |
  */

typedef SCCANNOINSERTICON40   SCCVWINSERTICON40, *PSCCVWINSERTICON40;
typedef SCCANNOINSERTICON41   SCCVWINSERTICON41, *PSCCVWINSERTICON41;
typedef SCCANNOINSERTICON81   SCCVWINSERTICON81, *PSCCVWINSERTICON81;

  /*
  |
  |  SCCVWINSERTBITMAP42 structure
  |
  */

typedef SCCANNOINSERTBITMAP42   SCCVWINSERTBITMAP42, *PSCCVWINSERTBITMAP42;
typedef SCCANNOINSERTBITMAP81   SCCVWINSERTBITMAP81, *PSCCVWINSERTBITMAP81;

  /*
  |
  |  SCCVWINSERTTEXT80 structure
  |
  */

typedef SCCANNOINSERTTEXT80   SCCVWINSERTTEXT80, *PSCCVWINSERTTEXT80;
typedef SCCANNOINSERTTEXT81   SCCVWINSERTTEXT81, *PSCCVWINSERTTEXT81;

  /*
  |
  |  SCCVWINSERTPARABREAK80 structure
  |
  */

typedef SCCANNOINSERTPARABREAK80   SCCVWINSERTPARABREAK80, *PSCCVWINSERTPARABREAK80;
typedef SCCANNOINSERTPARABREAK81   SCCVWINSERTPARABREAK81, *PSCCVWINSERTPARABREAK81;

  /*
  |
  |  SCCVWHIDEPARABREAK80 structure
  |
  */

typedef SCCANNOHIDEPARABREAK80   SCCVWHIDEPARABREAK80, *PSCCVWHIDEPARABREAK80;
typedef SCCANNOHIDEPARABREAK81   SCCVWHIDEPARABREAK81, *PSCCVWHIDEPARABREAK81;

  /*
  |
  |  SCCVWANNOGEN structure
  |
  */

typedef SCCANNOGEN   SCCVWANNOGEN, *PSCCVWANNOGEN;

/* Flags that can be specified in the dwFlags portion of annotations <XXX>80 and higher. */
#define SCCVWUNDONE   0x00000001  /* This annotation is marked as undone. */

   /*
   | SCCVWHILITESTYLE structure
   */

typedef SCCANNOHILITESTYLE41   SCCVWHILITESTYLE41, *PSCCVWHILITESTYLE41;
typedef SCCANNOHILITESTYLE81   SCCVWHILITESTYLE81, *PSCCVWHILITESTYLE81;

/* dwOptions of SCCCVWHILITESTYLE */
#define SCCVW_USEFOREGROUND      SCCANNO_USEFOREGROUND
#define SCCVW_USEBACKGROUND      SCCANNO_USEBACKGROUND
#define SCCVW_USECHARATTR        SCCANNO_USECHARATTR
#define SCCVW_USEUNDERLINECOLOR  SCCANNO_USEUNDERLINECOLOR
#define SCCVW_USETHINUNDERLINE   SCCANNO_USETHINUNDERLINE

  /*
  |
  |  SCCVW_ANNOTATIONEVENT
  |
  */

typedef SCCANNOTATIONEVENT40   SCCVWANNOTATIONEVENT40, *PSCCVWANNOTATIONEVENT40;
typedef SCCANNOTATIONEVENT41   SCCVWANNOTATIONEVENT41, *PSCCVWANNOTATIONEVENT41;

#define SCCVW_EVENTSINGLECLICK      SCCANNO_EVENTSINGLECLICK
#define SCCVW_EVENTDOUBLECLICK      SCCANNO_EVENTDOUBLECLICK
#define SCCVW_EVENTTRANSITIONINTO   SCCANNO_EVENTTRANSITIONINTO
#define SCCVW_EVENTTRANSITIONOUTOF  SCCANNO_EVENTTRANSITIONOUTOF
#define SCCVW_EVENTTRANSITION       SCCANNO_EVENTTRANSITION   /* Reserved for internal SCC use */
#define SCCVW_EVENTSINGLERIGHTCLICK SCCANNO_EVENTSINGLERIGHTCLICK

  /*
  |
  |  Location values for SCCVW_GOTOANNOTATION
  |
  */

#define SCCVW_GOTOFIRST   1
#define SCCVW_GOTOLAST    2
#define SCCVW_GOTOPREV    3
#define SCCVW_GOTONEXT    4

#define SCCVW_MASK        SCCANNO_MASK
#define SCCVW_ABSOLUTE    SCCANNO_ABSOLUTE

  /*
  |  Return values for SCCVW_GOTOANNOTATION
  */

#define SCCVW_FOUNDNONE    0
#define SCCVW_FOUNDOK      3

  /*
  |  dwDisplay values for SCCVWHILITETEXT
  */


#define SCCVW_BDEFAULT       SCCANNO_BDEFAULT
#define SCCVW_FDEFAULT       SCCANNO_FDEFAULT
#define SCCVW_USESTYLE       SCCANNO_USESTYLE

#define SCCVW_BBLACK         SCCANNO_BBLACK
#define SCCVW_BDARKRED       SCCANNO_BDARKRED
#define SCCVW_BDARKGREEN     SCCANNO_BDARKGREEN
#define SCCVW_BDARKYELLOW    SCCANNO_BDARKYELLOW
#define SCCVW_BDARKBLUE      SCCANNO_BDARKBLUE
#define SCCVW_BDARKMAGENTA   SCCANNO_BDARKMAGENTA
#define SCCVW_BDARKCYAN      SCCANNO_BDARKCYAN
#define SCCVW_BLIGHTGRAY     SCCANNO_BLIGHTGRAY
#define SCCVW_BGRAY          SCCANNO_BGRAY
#define SCCVW_BRED           SCCANNO_BRED
#define SCCVW_BGREEN         SCCANNO_BGREEN
#define SCCVW_BYELLOW        SCCANNO_BYELLOW
#define SCCVW_BBLUE          SCCANNO_BBLUE
#define SCCVW_BMAGENTA       SCCANNO_BMAGENTA
#define SCCVW_BCYAN          SCCANNO_BCYAN
#define SCCVW_BWHITE         SCCANNO_BWHITE

#define SCCVW_FBLACK         SCCANNO_FBLACK
#define SCCVW_FDARKRED       SCCANNO_FDARKRED
#define SCCVW_FDARKGREEN     SCCANNO_FDARKGREEN
#define SCCVW_FDARKYELLOW    SCCANNO_FDARKYELLOW
#define SCCVW_FDARKBLUE      SCCANNO_FDARKBLUE
#define SCCVW_FDARKMAGENTA   SCCANNO_FDARKMAGENTA
#define SCCVW_FDARKCYAN      SCCANNO_FDARKCYAN
#define SCCVW_FLIGHTGRAY     SCCANNO_FLIGHTGRAY
#define SCCVW_FGRAY          SCCANNO_FGRAY
#define SCCVW_FRED           SCCANNO_FRED
#define SCCVW_FGREEN         SCCANNO_FGREEN
#define SCCVW_FYELLOW        SCCANNO_FYELLOW
#define SCCVW_FBLUE          SCCANNO_FBLUE
#define SCCVW_FMAGENTA       SCCANNO_FMAGENTA
#define SCCVW_FCYAN          SCCANNO_FCYAN
#define SCCVW_FWHITE         SCCANNO_FWHITE

   /*
   | SCCVWFINDANNOTATION41 structure
   */

typedef SCCANNOFINDANNOTATION41   SCCVWFINDANNOTATION41, *PSCCVWFINDANNOTATION41;

   /*
   | dwFindOptions for SCCVWFINDANNOTATION
   | note: can be or'ed with SCCVW_ABSOLUTE or SCCVW_MASK
   */

#define  SCCVW_FINDFIRST        SCCANNO_FINDFIRST
#define  SCCVW_FINDLAST         SCCANNO_FINDLAST
#define  SCCVW_FINDPREV         SCCANNO_FINDPREV
#define  SCCVW_FINDNEXT         SCCANNO_FINDNEXT
#define  SCCVW_FINDFIRSTFROMPOS SCCANNO_FINDFIRSTFROMPOS

    /*
    | SCCVWGETANNOTATIONDATA
    */

typedef struct SCCVWGETANNOTATIONDATAtag
    {
    VTDWORD     dwSize;
    VTDWORD     dwUser;
    VTDWORD     dwData;
    VTDWORD     dwResultDataSize;
    VTVOID *pData;
    VTDWORD     dwDataType;
    } SCCVWGETANNOTATIONDATA, *PSCCVWGETANNOTATIONDATA;

/* Possible values returned in dwDataType above */
#define ADTYPE_NODATA       0
#define ADTYPE_URL          1
#define ADTYPE_BOOKMARK     2
#define ADTYPE_FTDFOBJTAG   3

typedef struct  SCCVWFTDFOBJECTTAGDATAtag
    {
    VTDWORD     dwObjectId;
    VTDWORD     dwOffset;
    VTBYTE      szReference[256];
    } SCCVWFTDFOBJECTTAGDATA, *PSCCVWFTDFOBJECTTAGDATA;

   /*
   | SCCVWFINDPOSITION41 structure
   */

typedef struct SCCVWFINDPOSITION41tag
   {
   VTDWORD    dwSize;
   VTDWORD    dwFindOptions;
   SCCVWPOS   sSearchPos;
   SCCVWPOS   sResultPos;
   } SCCVWFINDPOSITION41, *PSCCVWFINDPOSITION41;

   /*
   | dwFindOptions for SCCVW_FINDPOSITION
   */

#define  SCCVW_FINDFIRSTPOS         1
#define  SCCVW_FINDLASTPOS          2
#define  SCCVW_FINDPREVPOS          3
#define  SCCVW_FINDNEXTPOS          4
#define  SCCVW_FINDANCHORSELECTPOS  5
#define  SCCVW_FINDENDSELECTPOS     6
#define  SCCVW_FINDSTARTDISPLAYPOS  7
#define  SCCVW_FINDENDDISPLAYPOS    8
#define  SCCVW_FINDSTARTLINEPOS     9
#define  SCCVW_FINDENDLINEPOS       10
#define  SCCVW_FINDPREVLINEPOS      11
#define  SCCVW_FINDNEXTLINEPOS      12
#define  SCCVW_FINDPREVWORDPOS      13
#define  SCCVW_FINDNEXTWORDPOS      14
#define SCCVW_FINDPREVSECTION       15
#define SCCVW_FINDNEXTSECTION       16
#define SCCVW_FINDNEXTSELECTPOS     17
#define SCCVW_FINDPREVSELECTPOS     18


   /*
   | SCCVWMAPPOSITION41 structure
   */

typedef struct SCCVWMAPPOSITION41tag
   {
   VTDWORD       dwSize;
   VTDWORD       dwMapOptions;
   SCCVWPOS      sPos;
   VTDWORD       dwACC;
   } SCCVWMAPPOSITION41, * PSCCVWMAPPOSITION41;

   /*
   | dwMapOptions for SCCVW_MAPPOSITION
   */

#define  SCCVW_MAPACCTOPOS    0x0001
#define  SCCVW_MAPPOSTOACC    0x0002

    /*
    |   SCCVWMAPTREEPOSITION60 structure
    */

typedef struct SCCVWMAPTREEPOSITION60tag
    {
    VTDWORD   dwSize;
    VTDWORD   dwMapOptions;
    SCCVWPOS  sPos;
    VTDWORD   dwNode;
    } SCCVWMAPTREEPOSITION60, * PSCCVWMAPTREEPOSITION60;

	/*
    |   SCCVWMAPTREEPOSITION82 structure
    */

typedef struct SCCVWMAPTREEPOSITION82tag
    {
    VTDWORD   dwSize;
    VTDWORD   dwMapOptions;
    SCCVWPOS  sPos;
    VTDWORD   dwNode;
	VTDWORD   dwRecordNum;
    } SCCVWMAPTREEPOSITION82, * PSCCVWMAPTREEPOSITION82;

    /*
    |   dwMapOptions for SCCVW_MAPTREEPOSITION
    */

#define  SCCVW_MAPNODETOPOS     0x0001
#define  SCCVW_MAPPOSTONODE     0x0002

   /*
   | SCCVWSETSELECTION41 structure
   */

typedef struct SCCVWSETSELECTION41tag
   {
   VTDWORD     dwSize;
   SCCVWPOS    sAnchorPos;
   SCCVWPOS    sEndPos;
   } SCCVWSETSELECTION41, * PSCCVWSETSELECTION41;

   /*
   | SCCVWDISPLAYPOSITION41 structure
   */

typedef struct SCCVWDISPLAYPOSITION41tag
   {
   VTDWORD    dwSize;
   VTDWORD    dwDisplayOptions;
   SCCVWPOS   sPos;
   } SCCVWDISPLAYPOSITION41, * PSCCVWDISPLAYPOSITION41;

   /*
   | SCCVWCOMPPOSITIONS structure
   */

typedef struct SCCVWCOMPPOSITIONS41tag
   {
   PSCCVWPOS    pPosA;
   PSCCVWPOS    pPosB;
   } SCCVWCOMPPOSITIONS41, * PSCCVWCOMPPOSITIONS41;

   /*
   | dwDisplayOptions for SCCVW_DISPLAYOPTIONS
   */

#define  SCCVW_DISPLAYNEARTOP       0x00000001
#define  SCCVW_DISPLAYNEARMIDDLE    0x00000002
#define  SCCVW_DISPLAYNEARBOTTOM    0x00000004

  /*
  |  return values for SCCVW_KEYDOWN
  */

#define SCCVW_DOKEY        0
#define SCCVW_IGNOREKEY    1

   /*
   | SCCVWCOPY41 structure
   */

typedef struct SCCVWCOPY41tag
   {
   VTDWORD       dwSize;
   VTDWORD       dwOptions;
   VTDWORD       dwFormatId;
   SCCVWPOS      sStartPos;
   SCCVWPOS      sEndPos;
   VTHANDLE      dwDataHandle;
   VTDWORD       dwDataSize;
   VTDWORD       dwMessageId;
   } SCCVWCOPY41, * PSCCVWCOPY41;

  /*
  |
  |  Flags returned by the SCCVW_GETCLIPINFO message
  |
  */

#define SCCVW_NOTREADYCOPYTOCLIP  0x0000
#define SCCVW_CANCOPYTOCLIP     0x0001
#define SCCVW_CANCUTTOCLIP      0x0002
#define SCCVW_CANPASTEFROMCLIP  0x0004

  /*
  |
  |  Error values
  |
  */

#include "sccerr.h"

#define SCCVWERR_OK                   SCCERR_OK
#define SCCVWERR_INVALIDID            SCCERR_INVALIDID
#define SCCVWERR_FILTERLOADFAILED     SCCERR_FILTERLOADFAILED
#define SCCVWERR_FILTERALLOCFAILED    SCCERR_FILTERALLOCFAILED
#define SCCVWERR_NOFILTER             SCCERR_NOFILTER
#define SCCVWERR_DISPLAYINITFAILED    SCCERR_DISPLAYINITFAILED
#define SCCVWERR_CHUNKERINITFAILED    SCCERR_CHUNKERINITFAILED
#define SCCVWERR_FILEOPENFAILED       SCCERR_FILEOPENFAILED
#define SCCVWERR_UNKNOWNFAILURE       SCCERR_LEG_UNKNOWNFAILURE
#define SCCVWERR_BADFILE              SCCERR_BADFILE
#define SCCVWERR_EMPTYFILE            SCCERR_EMPTYFILE
#define SCCVWERR_PROTECTEDFILE        SCCERR_PROTECTEDFILE
#define SCCVWERR_DRMFILE              SCCERR_DRMFILE
#define SCCVWERR_UNSUPPORTEDCOMPRESSION SCCERR_UNSUPPORTEDCOMPRESSION
#define SCCVWERR_SUPFILEOPENFAILED    SCCERR_SUPFILEOPENFAILED
#define SCCVWERR_ALLOCFAILED          SCCERR_ALLOCFAILED
#define SCCVWERR_UNSUPPORTEDFORMAT    SCCERR_UNSUPPORTEDFORMAT
#define SCCVWERR_BADPARAM             SCCERR_BADPARAM
#define SCCVWERR_NOFILE               SCCERR_NOFILE
#define SCCVWERR_FEATURENOTAVAIL      SCCERR_FEATURENOTAVAIL
#define SCCVWERR_UNKNOWN              SCCERR_UNKNOWN
#define SCCVWERR_NODISPLAYENGINE      SCCERR_NODISPLAYENGINE
#define SCCVWERR_CANCEL               SCCERR_CANCEL
#define SCCVWERR_NOINIT               SCCERR_NOINIT
#define SCCVWERR_LASTPAGE             SCCERR_LASTPAGE
#define SCCVWERR_NOPAGE               SCCERR_NOPAGE
#define SCCVWERR_MESSAGEHANDLED       SCCERR_MESSAGEHANDLED
#define SCCVWERR_NONEFOUND            SCCERR_NONEFOUND
#define SCCVWERR_RAWTEXTDISABLED      SCCERR_RAWTEXTDISABLED
#define SCCVWERR_FILTERTIMEOUT        SCCERR_FILTERTIMEOUT
#define SCCVWERR_MACINITFAILED        SCCERR_MACINITFAILED
#define SCCVWERR_OTHERPRINTING        SCCERR_OTHERPRINTING
#define SCCVWERR_NODATATORENDER       SCCERR_NODATATORENDER
#define SCCVWERR_BADCREDENTIALS       SCCERR_BADCREDENTIALS
#define SCCVWERR_OUTPUT_SOL_MISSING   SCCERR_OUTPUT_SOL_MISSING
#define SCCVWERR_USEROFFSET           SCCERR_USEROFFSET


  /*
  |
  |  BailOut Messages
  |
  */
#define SCCVW_BAILOUT_MEMORY           SCCID_VWMESSAGE_MEMORY
#define SCCVW_BAILOUT_STREAMBAIL       SCCID_VWMESSAGE_STREAMBAIL
#define SCCVW_BAILOUT_FILEOPENFAILED   SCCID_VWMESSAGE_FILEOPENFAILED
#define SCCVW_BAILOUT_MISSINGELEMENT   SCCID_VWMESSAGE_MISSINGELEMENT
#define SCCVW_BAILOUT_BADFILE          SCCID_VWMESSAGE_BADFILE
#define SCCVW_BAILOUT_PROTECTEDFILE    SCCID_VWMESSAGE_PROTECTEDFILE
#define SCCVW_BAILOUT_DRMFILE          SCCID_VWMESSAGE_DRMFILE
#define SCCVW_BAILOUT_SUPFILEOPENFAILS SCCID_VWMESSAGE_SUPFILEOPENFAILS
#define SCCVW_BAILOUT_UNKNOWN          SCCID_VWMESSAGE_UNKNOWN
#define SCCVW_BAILOUT_EMPTYFILE        SCCID_VWMESSAGE_EMPTYFILE
#define SCCVW_BAILOUT_EMPTYSECTION     SCCID_VWMESSAGE_EMPTYSECTION
#define SCCVW_BAILOUT_NOFILTER         SCCID_VWMESSAGE_NOFILTER
#define SCCVW_BAILOUT_WRITEERROR       SCCID_VWMESSAGE_WRITEERROR
#define SCCVW_BAILOUT_FILECHANGED      SCCID_VWMESSAGE_FILECHANGED
#define SCCVW_BAILOUT_GPFAULT          SCCID_VWMESSAGE_GPFAULT
#define SCCVW_BAILOUT_DIVIDEBYZERO     SCCID_VWMESSAGE_DIVIDEBYZERO
#define SCCVW_BAILOUT_NOSUPPORTEDFILE  SCCID_VWMESSAGE_NOSUPPORTEDFILE
#define SCCVW_BAILOUT_OTHEREXCEPTION   SCCID_VWMESSAGE_OTHEREXCEPTION
#define SCCVW_BAILOUT_NOENGINE         SCCID_VWMESSAGE_NOENGINE
#define SCCVW_BAILOUT_NODATATORENDER   SCCID_VWMESSAGE_NODATATORENDER
#define SCCVW_BAILOUT_UNKNOWNNOTVIEWED SCCID_VWMESSAGE_UNKNOWNNOTVIEWED
#define SCCVW_BAILOUT_FILTERTIMEOUT    SCCID_VWMESSAGE_FILTERTIMEOUT
#define SCCVW_BAILOUT_CANCEL           SCCID_VWMESSAGE_CANCEL
#define SCCVW_BAILOUT_BADCREDENTIALS   SCCID_VWMESSAGE_BADCREDENTIALS

  /*
  |
  |  SCCVWOPTIONSPEC structure
  |
  */

typedef struct SCCVWOPTIONSPEC40tag
  {
  VTDWORD       dwSize;
  VTDWORD       dwId;
  VTDWORD       dwFlags;
  VTVOID *  pData;
  } SCCVWOPTIONSPEC40, * PSCCVWOPTIONSPEC40;

#define SCCVWOPTION_DEFAULT    0x0001
#define SCCVWOPTION_CURRENT    0x0002
#define SCCVWOPTION_ZOOMING    0x0004

  /*
  |
  |  Option values
  |
  */

#define SCCVW_WPMODE_DRAFT      1
#define SCCVW_WPMODE_NORMAL     2
#define SCCVW_WPMODE_PREVIEW    3

#ifdef WIN32
/*
|   Win32 requires the use of ENHMETAFILEs to
|   communicate with modern apps (Word, for instance)
*/
#define USE_ENHMETAFILE
#endif

#define  SCCVW_CLIPFORMAT_TEXT        0x00000001
#define  SCCVW_CLIPFORMAT_RTF         0x00000002
#define  SCCVW_CLIPFORMAT_AMI2        0x00000004
#define  SCCVW_CLIPFORMAT_AMI         0x00000008
#define SCCVW_CLIPFORMAT_PROWRITE     0x00000010
#define SCCVW_CLIPFORMAT_WORDSTAR     0x00000020
#define SCCVW_CLIPFORMAT_LEGACY       0x00000040
#define  SCCVW_CLIPFORMAT_WINBITMAP   0x00000080
#define  SCCVW_CLIPFORMAT_WINDIB      0x00000100
#define  SCCVW_CLIPFORMAT_WINMETAFILE 0x00000400
#define  SCCVW_CLIPFORMAT_WINPALETTE  0x00000200
#define SCCVW_CLIPFORMAT_MACPICT      0x00000800
#define SCCVW_CLIPFORMAT_OS2METAFILE  0x00001000
#define SCCVW_CLIPFORMAT_OS2BITMAP    0x00002000
#define SCCVW_CLIPFORMAT_OS2PALETTE   0x00004000
#define SCCVW_CLIPFORMAT_EPOCBITMAP   0x00008000
#define SCCVW_CLIPFORMAT_UNICODE      0x00010000
#if defined(_DARWIN_SOURCE)
#define SCCVW_CLIPFORMAT_TIFF         0x00020000
#endif /* _DARWIN_SOURCE */

#define SCCVW_CLIPSUBFORMAT_TABLE           0
#define SCCVW_CLIPSUBFORMAT_OPTIMIZEDTABS   1
#define SCCVW_CLIPSUBFORMAT_TABS            2

#define SCCVW_CLIPINCLUDE_CHARATTR          0x0001
#define SCCVW_CLIPINCLUDE_CHARSIZE          0x0002
#define SCCVW_CLIPINCLUDE_CHARFACE          0x0004
#define SCCVW_CLIPINCLUDE_PARAINDENTALIGN   0x0008
#define SCCVW_CLIPINCLUDE_PARASPACING       0x0010
#define SCCVW_CLIPINCLUDE_TABSTOPS          0x0020
#define SCCVW_CLIPINCLUDE_PAGEBREAKS        0x0040

#define  SCCVW_FITMODE_PIXELS            1
#define  SCCVW_FITMODE_ORIGINAL          SCCVW_FITMODE_PIXELS
#define  SCCVW_FITMODE_WINDOW            2
#define  SCCVW_FITMODE_WINDOWHEIGHT      3
#define  SCCVW_FITMODE_WINDOWWIDTH       4
#define  SCCVW_FITMODE_STRETCHWINDOW     5
#define  SCCVW_FITMODE_BEST              6
#define  SCCVW_FITMODE_IMAGESIZE         SCCUT_FITMODE_IMAGESIZE

#define  SCCVW_ROTATION_NONE           0
#define  SCCVW_ROTATION_90             90
#define  SCCVW_ROTATION_180            180
#define  SCCVW_ROTATION_270            270

#define SCCVW_DITHER_ON       1
#define SCCVW_DITHER_OFF      2

#define SCCVW_PRINTASPECT_SCALE          SCCUT_PRINTASPECT_SCALE
#define SCCVW_PRINTASPECT_ORIGINAL       SCCUT_PRINTASPECT_ORIGINAL
#define SCCVW_PRINTASPECT_STRETCH        SCCUT_PRINTASPECT_STRETCH
#define SCCVW_PRINTASPECT_IMAGESIZE		 SCCUT_PRINTASPECT_IMAGESIZE

#define SCCVW_INTLUNITSMASK      0x0001   /* bit 0: 0=metric 1=English */
#define SCCVW_ENGLISHUNITS    0x0001

#define SCCVW_INTL24HOURMASK  0x0002   /* bit 1: 0=24 hour time 1=12 hour time */
#define SCCVW_12HOURTIME         0x0002

typedef struct SCCVWPRINTMARGINStag
  {
  VTDWORD  dwTop;
  VTDWORD  dwBottom;
  VTDWORD  dwLeft;
  VTDWORD  dwRight;
  } SCCVWPRINTMARGINS, * PSCCVWPRINTMARGINS;

#define SCCVW_PRINT_ALLPAGES           1
#define SCCVW_PRINT_SELECTION          2
#define SCCVW_PRINT_PAGERANGE          3
#define SCCVW_PRINT_CURSECTION         4

#define SCCVW_DIALOG_NOHELP                 0x0001
#define SCCVW_DIALOG_NOMORE                 0x0002
#define SCCVW_DIALOG_NO3D                   0x0004
#define SCCVW_DIALOG_NOADDOPTIONSTOMENU     0x0008
#define SCCVW_DIALOG_NOADDDISPLAYTOMENU     0x0010
#define SCCVW_DIALOG_NOADDPRINTTOMENU       0x0020
#define SCCVW_DIALOG_NOADDCLIPBOARDTOMENU   0x0040
#define SCCVW_DIALOG_NOADDDOPRINTTOMENU     0x0080
#define SCCVW_DIALOG_NOADDDOCOPYTOMENU      0x0100
#define SCCVW_DIALOG_NOADDFONTZOOMTOMENU    0x0200
#define SCCVW_DIALOG_NOADDSHOWFULLSCREEN    0x0400
#define SCCVW_DIALOG_NOADDHIDDENCELLSTOMENU 0x0800

#define SCCVW_SYSTEM_RAWTEXT          0x0001
#define SCCVW_SYSTEM_NOTIMER          0x0002
#define SCCVW_SYSTEM_NOOPTIONSSAVE    0x0004
#define SCCVW_SYSTEM_NOREADAHEAD      0x0008
#define SCCVW_SYSTEM_UNICODE          0x0010
#define SCCVW_SYSTEM_CJKADDON         0x0020
#define SCCVW_SYSTEM_TEXTOUTPRINTERDRIVERBUG    0x0040
#define SCCVW_SYSTEM_TEXTOUTDISPLAYDRIVERBUG    0x0080
#define SCCVW_SYSTEM_NAMETEMPFILE     0x0100
#define SCCVW_SYSTEM_NDELTMPFILES     0x0200


/*
Special option support for CJK add-on system such as NJStar, CStar, TwinBridge
Functional code are handled in dufont.
Not documented in Viewer Spec, because we have not published this one yet.
*/

#define SCCVW_OLE_ENABLEDRAGDROP        0x0001

#define SCCVW_ARCHIVE_SAVENOP         0
#define SCCVW_ARCHIVE_SAVESELECTION   1
#define SCCVW_ARCHIVE_SAVEALL         2
#define SCCVW_ARCHIVE_SAVETHIS        3
#define SCCVW_ARCHIVE_VIEWTHIS        4


typedef struct SCCVWIMAGEZOOMtag
  {
  VTDWORD  dwXNu;
  VTDWORD  dwXDe;
  VTDWORD  dwYNu;
  VTDWORD  dwYDe;
  } SCCVWIMAGEZOOM, * PSCCVWIMAGEZOOM;

#define SCCVW_2DIGITYEARS          1
#define SCCVW_4DIGITYEARS          2
#define SCCVW_REGISTRYYEARS        3

#define SCCVW_SORT_NONE            1
#define SCCVW_SORT_NAME            2
#define SCCVW_SORT_SIZE            3
#define SCCVW_SORT_DATE            4
#define SCCVW_SORT_DESCENDING      0x80000000

#define SCCVW_ARC_RESTOREPATH      0x0001
#define SCCVW_ARC_HAVEPATH         0x0002

#define SCCVW_ARCHIVE_PROMPTONCOLLISION   0x00000001
#define SCCVW_ARCHIVE_PROMPTONILLEGALCHAR 0x00000010

#define SCCVW_ZOOM_NOP             0
#define SCCVW_ZOOM_IN              1
#define SCCVW_ZOOM_OUT             2
#define SCCVW_ZOOM_SELECTION       3
#define SCCVW_ZOOM_RESET           4

/* Options for SS print SCCID_SSPRINTFITTOPAGE */
#define  SCCVW_SSPRINTFITMODE_NOMAP         0
#define  SCCVW_SSPRINTFITMODE_FITTOPAGE     1
#define  SCCVW_SSPRINTFITMODE_FITTOWIDTH    2
#define  SCCVW_SSPRINTFITMODE_FITTOHEIGHT   3
#define  SCCVW_SSPRINTFITMODE_SCALE           4
#define  SCCVW_SSPRINTFITMODE_FITTOPAGES      5

/* Options for SS print SCCID_SSPRINTDIRECTION */
#define SCCVW_SSPRINTDIRECTION_ACROSS         0
#define SCCVW_SSPRINTDIRECTION_DOWN           1

/* Options for DB print SCCID_DBPRINTFITTOPAGE */
#define  SCCVW_DBPRINTFITMODE_NOMAP         0
#define  SCCVW_DBPRINTFITMODE_FITTOPAGE     1
#define  SCCVW_DBPRINTFITMODE_FITTOWIDTH    2
#define  SCCVW_DBPRINTFITMODE_FITTOHEIGHT   3

typedef struct SCCVWNUMBERFORMAT775tag
  {
  VTTCHAR cDecimalSep;
  VTTCHAR cThousandSep;  
  VTTCHAR cDateSep;
  VTTCHAR cTimeSep;
  VTTCHAR szCurrencySymbol[8];
  VTTCHAR szAM[8];
  VTTCHAR szPM[8];
  VTDWORD dwNumBytesAM;  /* store the number of bytes in the "AM" string */
  VTDWORD dwNumBytesPM;  /* store the number of bytes in the "PM" string */
  VTWORD  wCurrencyPosition;
  VTWORD  wShortDateOrder;
  } SCCVWNUMBERFORMAT775, * PSCCVWNUMBERFORMAT775;

typedef struct SCCVWNUMBERFORMATtag
  {
  VTTCHAR cDecimalSep;
  VTTCHAR cThousandSep;  
  VTTCHAR cDateSep;
  VTTCHAR cTimeSep;
  VTTCHAR szCurrencySymbol[8];
  VTTCHAR szAM[8];
  VTTCHAR szPM[8];
  VTDWORD dwNumBytesAM;  /* store the number of bytes in the "AM" string */
  VTDWORD dwNumBytesPM;  /* store the number of bytes in the "PM" string */
  VTWORD  wCurrencyPosition;
  VTWORD  wShortDateOrder;
  VTWORD  wShortDateYearDigits;
  VTWORD  wShortDateMonthDigits;
  VTWORD  wShortDateDayDigits;
  VTWORD  wShortDateFlags;
  } SCCVWNUMBERFORMAT, * PSCCVWNUMBERFORMAT;

#define SCCVW_CURRENCY_LEADS       0x0001   /* Currency symbol before the amount */
#define SCCVW_CURRENCY_TRAILS      0x0000   /* Currency symbol after the amount */
#define SCCVW_CURRENCY_SPACE       0x0002   /* Space between currency and amount */
#define SCCVW_CURRENCY_NOSPACE     0x0000   /* No space between currency and amount */

#define SCCVW_DATEORDER_MDY        0
#define SCCVW_DATEORDER_DMY        1
#define SCCVW_DATEORDER_YMD        2

typedef struct SCCVWDAYNAMEStag
  {
  VTWORD  aFullNames[7][16];
  VTWORD  aAbbrevNames[7][16];
  } SCCVWDAYNAMES, * PSCCVWDAYNAMES;

typedef struct SCCVWMONTHNAMEStag
  {
  VTWORD  aFullNames[13][16];
  VTWORD  aAbbrevNames[13][16];
  } SCCVWMONTHNAMES, * PSCCVWMONTHNAMES;

  /* Flags for SCCID_SCROLLFLAGS */

#define SCCVW_HSCROLL_NEVER     0x0001
#define SCCVW_HSCROLL_SOMETIMES 0x0002
#define SCCVW_HSCROLL_ALWAYS    0x0004
#define SCCVW_VSCROLL_NEVER     0x0008
#define SCCVW_VSCROLL_SOMETIMES 0x0010
#define SCCVW_VSCROLL_ALWAYS    0x0020

  /*
  |  Values for use with scrolling messages
  */

#define SCCSB_TOP               1
#define SCCSB_BOTTOM          2
#define SCCSB_LINELEFT    3
#define SCCSB_LINERIGHT   4
#define SCCSB_PAGELEFT    5
#define SCCSB_PAGERIGHT   6

#define SCCSB_LINEUP      3
#define SCCSB_LINEDOWN    4
#define SCCSB_PAGEUP      5
#define SCCSB_PAGEDOWN    6

#define SCCSB_POSITION    7

#define SCCSB_NEXTDOCPAGE 10    /* document pages rather than window pages */
#define SCCSB_PREVDOCPAGE 11

#define SCCSB_ENABLED     1
#define SCCSB_DISABLED    2


  /*
  |     Values for User Interface Version
  */
#define SCCVW_UI_CLASSIC    0   /* the way it always was (and still is for non-Windows) */
#define SCCVW_UI_WIN        1   /* the new Windows version */
#ifdef WIN32
#define GetUIVersion()      SCCVW_UI_WIN
#else
#define GetUIVersion()      SCCVW_UI_CLASSIC
#endif


  /*
  |     Values for page button messages
  */
#define SCCVW_PAGEBUTTONS           WM_USER
#define SCCVW_NOPAGEBUTTONS         WM_USER+1
#define SCCVW_PAGEBUTTONSTATE       WM_USER+2

#define PBS_PREVDISAB   0x00
#define PBS_PREVENAB    0x02
#define PBD_NEXTDISAB   0x00
#define PBS_NEXTENAB    0x01
#define PBS_DISAB       0x00
#define PBS_ENAB        0x03
#define PBS_FORCE       0x04



  /*
  |
  |  SCCVWSTATUSINFO50 structure
  |
  */

typedef struct SCCVWSTATUSINFO50tag
{
    VTDWORD   dwSize;
    VTDWORD   dwFlags;
    VTWORD    szText[256];
    VTDWORD   dwData;

} SCCVWSTATUSINFO50, * PSCCVWSTATUSINFO50;

/* Status flag values */
#define SCCVW_BEGINPROGRESS 0x0001
#define SCCVW_ENABLECANCEL    0x0002
#define SCCVW_PROGRESSTEXT    0x0004
#define SCCVW_PROGRESSVALUE   0x0008
#define SCCVW_ENDPROGRESS       0x0010
#define SCCVW_PROGRESSCANCEL    0x0020  /* The cancel button has been hit */


  /*
  |
  |  SCCVWIDEALSIZE50 structure
  |
  */

typedef struct SCCVWIDEALSIZE50tag
{
    VTDWORD   dwSize;
    VTDWORD   dwFlags;
    VTDWORD   dwMaxWidth;
    VTDWORD   dwMaxHeight;
    VTDWORD   dwResultWidth;
    VTDWORD   dwResultHeight;
} SCCVWIDEALSIZE50, * PSCCVWIDEALSIZE50;

  /*
  |
  |  SCCVWSECTIONCOUNTINFO51 structure
  |
  */

typedef struct SCCVWSECTIONCOUNTINFO51tag
{
    VTDWORD   dwSize;
    VTDWORD   dwFlags;
    VTDWORD   dwCount;
} SCCVWSECTIONCOUNTINFO51, * PSCCVWSECTIONCOUNTINFO51;

/* Possible values for dwFlags in SCCVWSECTIONCOUNTINFO51 */
#define SCCVW_SECTIONCOUNTINFO_TENTATIVE    0
#define SCCVW_SECTIONCOUNTINFO_FINAL        1

  /*
  |
  |  SCCVWSECTIONNAME structure
  |
  */
#define SECTIONNAME_MAX 40

typedef struct SCCVWSECTIONNAMEtag
{
    VTWORD wSectionNumber;
    VTWORD wzName[SECTIONNAME_MAX];
} SCCVWSECTIONNAME, * PSCCVWSECTIONNAME;


  /*
  |
  |  Legacy #defines
  |
  */

#define SCCVW_SELECTION      0x0001
#define SCCVW_WORDDRAG       0x0002
#define SCCVW_GRAMMAR        0x0004
#define SCCVW_EDITOR         0x0008
#define SCCVW_HORZSCROLL     0x0010
#define SCCVW_TAGSELECT      0x0020
#define SCCVW_TAGLEFTDOUBLE  0x0040
#define SCCVW_TAGNOTEXT      0x0080
#define SCCVW_NEEDRAWTEXT    0x0100
#define SCCVW_SPAM           0x0200
#define SCCVW_DRAGDROP       0x0400
#define SCCVW_REDRAWING		 0x0800
#define SCCVW_OPENCLOSE      0x2000
#define SCCVW_SELFBACKGROUND 0x4000
#define SCCVW_ADDOPTTOMENU   0x8000

#define SCCVW_FALLBACKTO     0x8000 /* high bit */

/* Font aliasing */
#define SCCVW_FONTALIAS_COUNT               0x0001
#define SCCVW_FONTALIAS_ALIASNAME           0x0002
#define SCCVW_FONTALIAS_GETALIASBYID        0x0004
#define SCCVW_FONTALIAS_GETALIASID          0x0008
#define SCCVW_FONTALIAS_REMOVEALIASBYID     0x0010
#define SCCVW_FONTALIAS_REMOVEALIASBYNAME   0x0020
#define SCCVW_FONTALIAS_REMOVEALL           0x0040
#define SCCVW_FONTALIAS_USEDEFAULTS         0x0080

#define SCCVW_FONTNAMEMAX          128
#define SCCVW_MAXFONTMAPENTRIES    100
#define SCCVW_MAXALIASES            16


typedef struct SCCVWFONTALIAS832tag
{
    VTDWORD dwSize;                          /* sizeof(SCCVWFONTALIAS) */
    VTDWORD dwAliasID;                       /* ID of the aliasing in the current list of aliases */
    VTDWORD dwFlags;                         /* set of flags */
    VTWORD  szwOriginal[SCCVW_FONTNAMEMAX];  /* original name of the font */
    VTWORD  szwAlias[SCCVW_FONTNAMEMAX];     /* new font name to use in place of original name */
} SCCVWFONTALIAS832, * PSCCVWFONTALIAS832;

typedef struct SCCVWFONTALIAStag
{
    VTDWORD dwSize;                                           /* sizeof( SCCVWFONTALIAS ) */
    VTDWORD dwAliasID;                                        /* ID of the aliasing in the current list of aliases */
    VTDWORD dwFlags;                                          /* set of flags */
    VTWORD  szwOriginal[ SCCVW_FONTNAMEMAX ];                 /* original name of the font */
    VTWORD  szwAlias[ SCCVW_FONTNAMEMAX * SCCVW_MAXALIASES ]; /* new font name(s) to use in place of original name */
} SCCVWFONTALIAS, * PSCCVWFONTALIAS;

typedef struct SCCVWFONTALIASMAPtag
{
    VTDWORD     dwCount;                                             /* number of entries in the map */
    VTHANDLE    hOriginal[SCCVW_MAXFONTMAPENTRIES];                  /* memory handles for original font names */
    VTHANDLE    hAlias[SCCVW_MAXFONTMAPENTRIES];                     /* memory handles for alias font names */
    VTLPWORD    szwOriginal[SCCVW_MAXFONTMAPENTRIES];                /* array of all the original font names */
    VTLPWORD    szwAlias[SCCVW_MAXFONTMAPENTRIES];                   /* array of all the alias font name arrays */
} SCCVWFONTALIASMAP, * PSCCVWFONTALIASMAP;


typedef struct SCCVWUNIXOPTIONSFILEINFOtag
{
    VTDWORD dwSize;                         /* sizeof(SCCVWUNIXOPTIONSFILEINFO) */
    VTBYTE  szFName[SCCVW_FILENAMEMAX];     /* array holding the name of the options file */
}SCCVWUNIXOPTIONSFILEINFO;


/* added so that user can set/get name of the resource (LO) DLL */
#define SCCVW_RESOURCEIDMAX (6 * sizeof(VTTCHAR))

typedef struct SCCVWRESOURCEIDtag
{
    VTDWORD   dwSize;                               /* sizeof(SCCVWRESOURCEID) */
    VTBYTE    szResourceID[SCCVW_RESOURCEIDMAX];    /* 0-5 character ID defining version of the LO DLL w/ unique resources */
} SCCVWRESOURCEID, * PSCCVWRESOURCEID;



/* Added for bidirectional text functionality - Deprecated, 8.3.5 */
#define SCCVW_REORDER_NOVALUE  SCCUT_REORDER_NOVALUE        /* do not set an algorithm at all --- this is the default */
#define SCCVW_REORDER_NONE     SCCUT_REORDER_NONE           /* no text is reordered in the display */
#define SCCVW_REORDER_UNICODE  SCCUT_REORDER_UNICODE        /* use the unicode bidirectional algorithm for reordering */
#define SCCVW_REORDER_FULL     SCCUT_REORDER_FULL	        /* mirror each line individually */

/*
	New BiDi options as of 8.3.5 

	SCCUT_REORDER_UNICODE_OFF
	SCCUT_REORDER_UNICODE_LTOR
	SCCUT_REORDER_UNICODE_RTOL

*/


/* Tree engine saving */
typedef struct SCCVWSAVENODEtag
{
    VTDWORD     dwSize;
    VTDWORD     dwNode;
    VTDWORD     dwFlags;
#define SCCVW_SAVENODEFLAG_RESTORE_PATH 0x00000001
    /*** Use 256 here because that is what DETREE uses for MAX_PATH ***/
    VTTCHAR     szPath[256];
    VTTCHAR     szName[256];
} SCCVWSAVENODE;

/* Options callback */
#define VWOPT_UPDATE_PRINTINFO  0x00000001          /* Update the printinfo at the end of the callback */

/* Options for FI */

#define SCCVW_FI_NORMAL              0
#define SCCVW_FI_EXTENDEDTEST        1

/* Option values for filter performance */

#define SCCVW_FILTER_NORMALPERFORMANCE          0
#define SCCVW_FILTER_OPTIMIZEDFORTEXT           1

#define SCCVW_FILTER_LZW_ENABLED                0
#define SCCVW_FILTER_LZW_DISABLED               2

#define SCCVW_FILTER_JPG_ENABLED                0
#define SCCVW_FILTER_JPG_DISABLED               4

#define SCCVW_FILTER_NORMALSUBOBJECTS           0
#define SCCVW_FILTER_ENABLEALLSUBOBJECTS        32

#define SCCVW_ANTIALIAS_OFF                     0
#define SCCVW_ANTIALIAS_ALL                     1

/* Options for chunker memory usage */
#define SCCVW_DOCUMENTMEMORYMODE_SMALLEST  1     /* 4MB  */
#define SCCVW_DOCUMENTMEMORYMODE_SMALL     2     /* 16MB  <- Default value (current setting, as of 8.2.2) */
#define SCCVW_DOCUMENTMEMORYMODE_MEDIUM    3     /* 64MB */
#define SCCVW_DOCUMENTMEMORYMODE_LARGE     4     /* 256MB <- This was how it was set in 8.2.0 */
#define SCCVW_DOCUMENTMEMORYMODE_LARGEST   5     /* 1 GB */

/* Added for SCCVW_DRAMAMINE_1 message support */
typedef struct SCCVWDRAMAMINE1tag
{
  VTBYTE  szBytes1[64];
  VTBYTE  szBytes2[64];
  VTWORD  word1;
} SCCVWDRAMAMINE1, * PSCCVWDRAMAMINE1;

#ifndef SCCUT_H
typedef IO_ENTRYSC VTVOID (IO_ENTRYMOD * PDLL_LOAD_CALLBACK_FUNC)(PSCCVWDLLLOADCALLBACK pCallBackData);
#endif

/* Defines for file access */
#ifndef _SCCDA_H
#define OIT_FILEACCESS_PASSWORD  1
#define OIT_FILEACCESS_NOTESID   2
#endif

typedef struct SCCVWFILEACCESSDATAtag
{
    VTDWORD   dwSize;            /* size of this structure */
    VTBOOL    bProcessed;        /* flag if the request was processed */
    VTDWORD   dwRequestId;       /* type of information requested */
    VTWORD    wFIId;             /* FI id of reference file */
    VTDWORD   dwSpecType;        /* file spec type */
    VTVOID   *pSpec;             /* pointer to a file spec  */
    VTSYSVAL  pReturnData;       /* structure to place requested information in to return to OIT */
    VTDWORD   dwReturnDataSize;  /* size of the return data structure */
	 VTDWORD   dwAttemptNumber;   /* The number of times the callback has already been called for the currently requested item of information */
} SCCVWFILEACCESSDATA, * PSCCVWFILEACCESSDATA;

/* Status callback function signature */
typedef VTDWORD (*VWSTATCALLBACKFN)( VTHANDLE hUnique, VTDWORD dwID, VTSYSVAL pCallbackData, VTSYSVAL pAppData);

IO_ENTRYSC IOERR IO_ENTRYMOD VWSetupDllLoadCallback(PDLL_LOAD_CALLBACK_FUNC lpFunc, VTLPVOID lpVector, VTDWORD dwVectorLength);
IO_ENTRYSC VTDWORD IO_ENTRYMOD VWSetStatCallback(VWSTATCALLBACKFN pCallback, VTHANDLE hUnique, VTSYSVAL pAppData);

/* Constants to use for wParam in VWFindAnno() */
/* SCCVW_FA_NONE is the value specified in the API for SCCVW_FINDANNOTATION */
#define SCCVW_FA_NONE   SCCANNO_FA_NONE
#define SCCVW_FA_ENDPOS SCCANNO_FA_ENDPOS

	 /* 
	  |  Defines for VW status callback
     */
#ifndef _SCCDA_H
#define OIT_STATUS_WORKING		0
#define OIT_STATUS_CONTINUE		SCCERR_OK
#define OIT_STATUS_CANCEL		SCCERR_CANCEL
#define OIT_STATUS_ABORT		SCCERR_ABORT
#endif

#ifdef __cplusplus
}
#endif

#ifdef SCC_PACKED_BY_SCCVW_H
#pragma pack(pop)
#undef SCC_PACKED_BY_SCCVW_H
#undef SCC_PACK_SET
#endif /* SCC_PACKED_BY_SCCVW_H */

#endif /*SCCVW_H*/
