package edu.georgetown.gucs.experiment;

import edu.georgetown.gucs.utility.Pair;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Evan B.
 * @since 6/18/14.
 */
public class ExperimentResults implements Comparable {

    //make sure to
    private int averageMScore = 0;
    private int averageEScore = 0;

    List<Integer> eResults;
    List<Integer> mResults;

    TrialParameters trialParameters;

    /**
     *
     * Constructor to initalize an empty trialParameters
     *
     */
    ExperimentResults(){

       this.trialParameters = new TrialParameters();

    }


    ExperimentResults(TrialParameters trialParameters) {

        this.trialParameters = trialParameters;

    }

    public void setThreadName(String threadName) {
    }

    public void setDictionarySize(int dictSize) {

    }

    public void setMatcherResults(ArrayList<Integer> mResults) {

        this.mResults = (!mResults.isEmpty()) ? mResults : null;

    }

    public void setExactResults(ArrayList<Integer> eResults) {


        this.eResults = (!eResults.isEmpty()) ? eResults : null;

    }

    public void setMatcherScore(int averageScore) {

        averageMScore = averageScore;

    }

    public void setExactScore(int averageScore) {
        averageEScore = averageScore;
    }

    public String getMangler() {
        return trialParameters.getMangler();
    }

    public String getMatcherName() {
        return trialParameters.getMatcherName();
    }

    public int getAverageMatcherScore() {
        return averageMScore;
    }

    public int getAverageExactScore() {
        return averageEScore;
    }

    public String getFileTokenInfo() {
        return trialParameters.getFileToken().toString();
    }

    public Pair<Double,Double> getIdfRange() { return trialParameters.getIDFRange(); };

    public String getTokenizers() {

        StringBuilder strBuf = new StringBuilder();
        for (String str : trialParameters.getTokenizerNames()) {
            strBuf.append(str).append("\n");
        }

        return strBuf.toString();
    }

    public void printTrialParams() {

        System.out.println("[Mangler] " + trialParameters.getMangler());

        System.out.println("[Matcher Name] " + trialParameters.getMatcherName());

        System.out.println("[Average Matcher Score] " + averageMScore);

        System.out.println("[Average Exact Score] " + averageEScore);

        System.out.println("[IDF Range] " + getIdfRange().getA() + "-" +
        getIdfRange().getB());

        System.out.println("[File Token Information]" + trialParameters.getFileToken());

        for (String str : trialParameters.getTokenizerNames()) {
            System.out.println("" + str);
        }

        System.out.println("\n\n --------------------------------------------------");

    }


    @Override
    public int compareTo(Object o) {
        return ((ExperimentResults) o).getMangler().compareTo(getMangler());
    }
}
