package edu.georgetown.gucs.testScript;

import javax.xml.stream.XMLInputFactory;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.XMLStreamReader;
import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Iterator;

/**
 * @author Evan Bloomberg
 * @since 6/5/14.
 * Store FilePaths 2 compare
 * check if it's an XML File
 * --> if XML { get tokens || fingerprint || etc. }
 * --> if not XML MD5
 * <p>
 * sort output from fileCheck
 * Match if all elements are the same :)
 */

public class TestMatch {

    String[] testFiles;
    ArrayList<String> validatedData;

    ArrayList<String> testData;


    TestMatch(String testFiles) {


        this.testFiles = parsePath(testFiles);

    }

    public void compare() {
        try {
            validatedData = readFile(testFiles[0]);
            testData = readFile(testFiles[1]);

            matcher();

        } catch (IOException io) {

            io.getMessage();

        }
    }

    private void matcher() {
/*
        if(!isXml){
          if(testData.get(testData.size()) == validatedData.get(validatedData.size())) {
                System.out.println("Files are an exact match");
                return;
            }
        }
  */

        ArrayList<String> copyValidData = new ArrayList<>(validatedData);
        ArrayList<String> copyTestData = new ArrayList<>(testData);

        Iterator<String> it1 = validatedData.iterator();
        Iterator<String> it2 = testData.iterator();

        System.out.println("[validdata] " + validatedData.size() +
                " [testDataSize] " + testData.size());

        if (validatedData.size() != testData.size()) {
            System.out.println("TestData is not equal");

        }

        while (it1.hasNext() && it2.hasNext()) {

            String it1Next = it1.next();
            String it2Next = it2.next();

            if (it2Next.trim().equalsIgnoreCase(it1Next.trim())) {
                it1.remove();
                it2.remove();
            }

        }

        if (testData.size() == 0 &&
                validatedData.size() == 0) {

            System.out.println("Success");

        } else {
            System.out.println("[testSize] " + testData.size() + " [cptest] " + copyTestData.size() +
                    " [validSize] " + validatedData.size() + " [cpValid] " + copyValidData.size());

           /* int counter = 0;
            int i = 0;
            int j = 0;
            while (testData.size() != counter || validatedData.size() != counter) {

                if (testData.get(i).equals(validatedData.get(j))) {
                    testData.remove(i);
                } else {
                    counter++;
                }

            }*/

        }
    }

    private ArrayList<String> readFile(String str) throws IOException {

        ArrayList<String> results = new ArrayList<>();
        XMLInputFactory inputFactory = XMLInputFactory.newInstance();
        try (InputStream in = new FileInputStream(str)) {

            //try to see if the file is XML and read its values
            try {
                XMLStreamReader streamReader = inputFactory.createXMLStreamReader(in);
                while (streamReader.hasNext()) {

                    if (streamReader.isStartElement()) {

                        /*
                        if(streamReader.getLocalName().equals("base64Fingerprint")) {
                            results.add(streamReader.getElementText());
                            System.out.println(streamReader.getElementText());
                        }*/


                        //  System.out.println("[Local Name] " + streamReader.getLocalName() + " "
                        //         + streamReader.getAttributeValue(0));
                        results.add(streamReader.getAttributeValue(0));

                    }
                    streamReader.next();
                }
            } catch (XMLStreamException e) {

                try (InputStreamReader isr = new InputStreamReader(in);
                     BufferedReader br = new BufferedReader(isr)) {

                    String line;
                    StringBuilder sb = new StringBuilder();
                    while ((line = br.readLine()) != null) {

                        //   results.addAll(Arrays.asList(line.split(" ")));
                        //   if(!line.equals(" "))
                        sb.append(line.trim()).append(" ");
                    }
                    // System.err.println(sb.toString());
                    results.addAll(Arrays.asList(sb.toString().split(" ")));
                    sb.setLength(0);
                }
            }
        }
        Collections.sort(results);
        return results;
    }

    private String[] parsePath(String str) {

        return str.split("\\|");
    }

    private String getPathEnd(String str) {

        return str.substring(str.lastIndexOf("/") + 1,
                str.length());

    }
}

