package edu.georgetown.gucs.testScript;
import java.util.ArrayList;

/**
 * @author Evan Bloomberg
 */
public class Trials extends SdTest {


    private ArrayList<String> commandLineArguments = new ArrayList<String>();
    private String outputFile;
    private boolean isSave;

    Trials(String trial) {
        this.outputFile = trial ;

        commandLineArguments.add("java");
        commandLineArguments.add("-jar");
        commandLineArguments.add(sdTextpath);
        commandLineArguments.add(trial);

    }


    public String[] getArgs(){
        return commandLineArguments.toArray(
                new String[commandLineArguments.size()]);
    }

    public void setDictionary(String dict) {
        commandLineArguments.add("--dictionary");
        commandLineArguments.add(basePathOutput + dict);
    }


    public void setDirectory(String directory) {
        commandLineArguments.add("--directory");
        commandLineArguments.add(basePathInput + directory);
    }

    public void setInput(String input) {
        commandLineArguments.add("--input");
        commandLineArguments.add(basePathInput + input);
    }

    public void setMatcher(String matcher) {
        commandLineArguments.add("--matcher");
        commandLineArguments.add(matcher);
    }

    public void setMinIdf(String minIdf) {
        commandLineArguments.add("--min-idf");
        commandLineArguments.add(minIdf);
    }

    public void setMaxIdf(String maxIdf) {
        commandLineArguments.add("--max-idf");
        commandLineArguments.add(maxIdf);
    }

    public void setFingerprint(String fingerprint) {
        commandLineArguments.add("--fingerprint");
        commandLineArguments.add(basePathOutput + fingerprint);
    }

    public void setTargetFingerprint(String targetFingerprint) {
        commandLineArguments.add("--targetFingerprint");
        commandLineArguments.add(basePathOutput+ targetFingerprint);
    }
    public void setSourceFingerprint(String sourceFingerprint) {
        commandLineArguments.add("--sourceFingerprint");
        commandLineArguments.add(basePathOutput + sourceFingerprint);
    }

    public void setOutputFile(String str) {

        if (str.equalsIgnoreCase("false")) {
            isSave = true;

        } else {
            commandLineArguments.add("--output");
            commandLineArguments.add( basePathOutput + outputFile);
            isSave = false;
        }

    }

    public boolean getSave() { return isSave; }

    public void setConfig(String config) {
        commandLineArguments.add("--config");
        commandLineArguments.add(basePathInput+"../configuration_files/" + config);
    }


    public String getFileName() { return outputFile != null ? outputFile : null; }

    public String[] getTrialCommand() {

        return commandLineArguments.toArray(
                new String[commandLineArguments.size()]);
    }
}
